//============================================================== BUTTONS
// var buttonX         = [   .1, .471,  .833,  .764  ]; // button coordinates
// var buttonY         = [   .1, .391,  .370,  .575  ];
var buttonState     = [   -1,   -1,     -1,    -1  ]; // button states

console.log("server here");
//============================================================== SERVER START
// include express object fo http and make some magic
var express = require('express'); 
var app = express();
var server = app.listen(3000);
// set the content directory 
app.use(express.static('public'));
// include socket object
var socket = require('socket.io');
// object for websockets
var io = socket(server);

//include onoff object for gpios
var Gpio = require('onoff').Gpio;

var finish_input = new Gpio(14,'in','rising'); // finish lichtschranke input
var trigger_relase_output = new Gpio(17, 'out'); //tigger output
//trigger_relase_output.writeSync(1);var PIN27 = new Gpio(27,'out'); // weiche 1
var PIN22 = new Gpio(22,'out'); // weiche 2
var PIN10 = new Gpio(10,'out'); // weiche 3
var PIN09 = new Gpio(9,'out');

var switch_count = 3;

var pins = [PIN09,PIN22,PIN10]; //, trigger_relase_output];
//============================================================== SOCKET EVENTS

// set handler on every new connection
io.sockets.on('connection',newConnection);

// new connection callback
function newConnection(socket) {
    console.log('new connection: ' + socket.id  + '  ' + socket.handshake.address);
    
    // send initial data
    var data = {
        //  x: buttonX,
        //  y: buttonY,
         state: buttonState
    }
    socket.emit('initMessage',data); 

    // set handler for incoming message
    socket.on('buttonMessage', receiveButton);
    
    // button callback
    function receiveButton(data){
        console.log('new message:');
        console.log(data);
        buttonState[data.index] = data.state; // update butto states
        
       for(var i = 0; i < switch_count; i++){
           if(buttonState[i+1] == 1){
               pins[i].writeSync(1);
           } else {
               pins[i].writeSync(0);
           }
       }

       // use first button as start button
       if(data.index == 0 && data.state == 1 ){
           console.log("trigger on");
           //buttonState[0] = -1; // reset start button to -1
           //data.state = -1; // also update the data tahat will be sent to all cleints
           trigger_relase_output.write(1);
           setTimeout(function(){ // timeout for pulse length 
            trigger_release();
           },500);
       }

        io.sockets.emit('buttonMessage',data); // send received change to all connected sockets, also back to the sender
                                       
    }

}

function unexportOnClose(){ //function to run when exiting program
    for(var i = 0; i < pins.length; i++){
        pins[i].writeSync(0);
        pins[i].unexport();
    }
}

process.on('SIGINT', unexportOnClose); //function to run when user closes using ctrl+cc

//============================================================== FINISH INPUT
// finish_input.watch((err,value) => {
//     if(err){
//         throw err;
//     }
//     console.log("finish");
// }
// );


//============================================================== RELEASE TRIGGER OUTPUT

function trigger_release(){
    trigger_relase_output.write(0);
    console.log("trigger off");
}




